#define PROGNAME "Delayhandler"
#include "bbs:bgcheck/bgcheck.h"
#include <dos/dostags.h>

static const char VersionTag[] = "\0$VER: "PROGNAME" "REVISION" ("REVDATE")";


void end(void);
struct delayfile **fixdata(char **area,struct delayfile **filedata);
void upload(struct delayfile **filedata);


int main(int argc, char *argv[])
{
	BPTR	fh=NULL,lock=NULL;

	char	buffer[255],	
			buffer2[255],
			*p=NULL,
			**main_config=NULL,
			delaypath[255]="bbs:bgcheck/Delay/",
			**area=NULL;

	ULONG	pos=0,
			pos2=0,
			len=0,
			delay=30;

	BOOL	match=FALSE;

	struct	FileInfoBlock *fib=NULL;
	struct	delayfile	**filedata=NULL;


	lock  = Lock( "ENV:Delayhandler_is_running", ACCESS_READ );
	if (lock)
	{
		UnLock(lock);
		return(0);
	}
	else 
	{
		fh=Open("ENV:Delayhandler_is_running",MODE_NEWFILE);
		if (fh) Close(fh);
	}


	strcpy(buffer,"bbs:bgcheck/bgfilehandler.config");
	fh=Open(buffer,MODE_OLDFILE);
	if (fh) 
	for (pos=0;FGets(fh,buffer,254);pos++)
	{
		main_config=(char **) realloc(main_config,(pos+1)*sizeof(char *));
		main_config[pos]=NULL;
		len=strlen(buffer);
		if (buffer[len-1]=='\n') buffer[--len]='\0';
		upperstring(buffer);
		main_config[pos]=(char *) malloc (len+1);
		if (main_config[pos]!=NULL)
			strcpy(main_config[pos],buffer);
	}
	Close(fh);
	main_config=(char **) realloc(main_config,(pos+1)*sizeof(char *));
	main_config[pos]=NULL;


	p=getconfig(main_config,"DELAY_PATH");
	if(p)
	{
		strcpy(delaypath,p);
		len=strlen(delaypath);
		if (delaypath[len-1]!='/' && delaypath[len-1]!=':')
		{
			strcat(delaypath,"/");
		} 
		
	}

	p=getconfig(main_config,"DELAY_SCAN_TIME");
	if(p)
	{
		delay=atoi(p);
		if (delay<=4) delay=5;
	}




	for (pos=0;main_config[pos];pos++)
		free(main_config[pos]);
	free (main_config);




		strcpy(buffer,delaypath);
		if (buffer[len-1]=='/') buffer[len-1]='\0';
		area=(char **) realloc(area,sizeof(char *));
		fh=Lock(buffer,ACCESS_READ);
		if (fh)	UnLock(fh);
		else
		{
			len=strlen(buffer);
			fh=CreateDir(buffer);
			UnLock(fh);
		}

		filedata=(struct delayfile **) realloc(filedata,sizeof(struct delayfile *));
		filedata[0]=NULL;


		for (;;)
		{
			strcpy(buffer,delaypath);
			len=strlen(buffer);
			if (buffer[len-1]=='/') buffer[len-1]='\0';
			fib = AllocDosObject(DOS_FIB, NULL);
			fh=Lock(buffer,ACCESS_READ);
			area=(char **) realloc(area,sizeof(char *));
			area[0]=NULL;	



			if (fh)
			{	

				ParsePatternNoCase("#?.dat", buffer2, 255);
				Examine(fh,fib);
				pos=0;
				while (ExNext(fh,fib))
				{	
					strcpy(buffer,fib->fib_FileName);
					if (MatchPatternNoCase(buffer2, buffer))
					{
						area=(char **) realloc(area,(pos+1)*sizeof(char *));
						area[pos]=NULL;
						len=strlen(buffer);
						area[pos]=(char *) malloc (len+1);
						if (area[pos]!=NULL)
							strcpy(area[pos],buffer);
						pos++;
					}
				}
				area=(char **) realloc(area,(pos+1)*sizeof(char *));
				area[pos]=NULL;
			}
			UnLock(fh);
			FreeDosObject(DOS_FIB,fib);




			if (area[0]==NULL) end();



			for (pos=0;area[pos];pos++)
			{

				strcpy(buffer,area[pos]);
				buffer[strlen(buffer)-4]='\0';
				match=FALSE;
				pos2=0;
				while (filedata[pos2])
				{
					if (strcmp(filedata[pos2]->filename,buffer)==0)
						match=TRUE;
					pos2++;
				}
			
				if (!match)
				{
					filedata=(struct delayfile **) realloc(filedata,(pos2+1)*sizeof(struct delayfile *));
					filedata[pos2]=NULL;
					len=strlen(buffer);
					filedata[pos2]=(struct delayfile *) malloc (sizeof(struct delayfile));
					if (filedata[pos2]!=NULL)
					{
						sprintf(buffer2,"%s%s",delaypath,area[pos]);
						fh=Open(buffer2,MODE_OLDFILE);
						if (fh)
						{
							FGets(fh,buffer2,254);
							len=strlen(buffer2);
							buffer2[len-1]='\0';
							strcpy(filedata[pos2]->delaydate,buffer2);

							FGets(fh,buffer2,254);
							len=strlen(buffer2);
							buffer2[len-1]='\0';
							strcpy(filedata[pos2]->delaytime,buffer2);

							FGets(fh,buffer2,254);
							len=strlen(buffer2);
							buffer2[len-1]='\0';
							strcpy(filedata[pos2]->filename,buffer2);

							FGets(fh,buffer2,254);
							strcpy(filedata[pos2]->filepath,delaypath);

							FGets(fh,buffer2,254);
							len=strlen(buffer2);
							buffer2[len-1]='\0';
							strcpy(filedata[pos2]->nodenumber,buffer2);

							FGets(fh,buffer2,254);
							len=strlen(buffer2);
							buffer2[len-1]='\0';
							strcpy(filedata[pos2]->handle,buffer2);

							FGets(fh,buffer2,254);
							len=strlen(buffer2);
							buffer2[len-1]='\0';
							strcpy(filedata[pos2]->confpath,buffer2);

							FGets(fh,buffer2,254);
							len=strlen(buffer2);
							buffer2[len-1]='\0';
							strcpy(filedata[pos2]->dirinkbyte,buffer2);

							FGets(fh,buffer2,254);
							len=strlen(buffer2);
							buffer2[len-1]='\0';
							strcpy(filedata[pos2]->slotnumber,buffer2);

							FGets(fh,buffer2,254);
							len=atoi(buffer2);
							filedata[pos2]->confnumber=len;
			
					
							Close(fh);
						}

					}
					filedata=(struct delayfile **) realloc(filedata,(pos2+2)*sizeof(struct delayfile *));
					filedata[pos2+1]=NULL;

				}
			}


		filedata=fixdata(area,filedata);


		upload(filedata);




		
		for (pos=0;area[pos];pos++)
			free(area[pos]);


			Delay(delay*TICKS_PER_SECOND);



		}

		free (area);

		for (pos=0;filedata[pos];pos++)
			free(filedata[pos]);
		free(filedata);
		end();


}

void end(void)
{

		DeleteFile("ENV:Delayhandler_is_running");
		Exit(0);
}


struct delayfile **fixdata(char **area,struct delayfile **filedata)
{
	ULONG	pos=0,
			pos2=0,
			pos3=0;
	BOOL	match=FALSE;
	char	buffer[255];
	struct	delayfile **filedata2=NULL;



	filedata2=(struct delayfile **) realloc(filedata2,sizeof(struct delayfile *));
	filedata2[0]=NULL;


	pos=0;
	pos3=0;
	while (filedata[pos])
	{
		
		match=FALSE;
		pos2=0;
		while (area[pos2])
		{
			strcpy(buffer,area[pos2]);
			buffer[strlen(buffer)-4]='\0';
			if (strcmp(filedata[pos]->filename,buffer)==0)
				match=TRUE;
			pos2++;
		}
		if (match)
		{
			filedata2=(struct delayfile **) realloc(filedata2,(pos3+1)*sizeof(struct delayfile *));
			filedata2[pos3]=NULL;
			filedata2[pos3]=(struct delayfile *) malloc (sizeof(struct delayfile));
			if (filedata2[pos3]!=NULL)
			{
				strcpy(filedata2[pos3]->delaydate, filedata[pos]->delaydate);
				strcpy(filedata2[pos3]->delaytime, filedata[pos]->delaytime);
				strcpy(filedata2[pos3]->filename,  filedata[pos]->filename);
				strcpy(filedata2[pos3]->filepath,  filedata[pos]->filepath);
				strcpy(filedata2[pos3]->nodenumber,filedata[pos]->nodenumber);
				strcpy(filedata2[pos3]->handle,    filedata[pos]->handle);
				strcpy(filedata2[pos3]->confpath,  filedata[pos]->confpath);
				strcpy(filedata2[pos3]->dirinkbyte,filedata[pos]->dirinkbyte);
				strcpy(filedata2[pos3]->slotnumber,filedata[pos]->slotnumber);
				filedata2[pos3]->confnumber=filedata[pos]->confnumber;
			}
			filedata2=(struct delayfile **) realloc(filedata2,(pos3+2)*sizeof(struct delayfile *));
			filedata2[pos3+1]=NULL;
			pos3++;
		}
		pos++;
	}

	for (pos=0;filedata[pos];pos++)
		free(filedata[pos]);
	free(filedata);

	return(filedata2);
}

void upload(struct delayfile **fileinfo)
{

	struct DateStamp *stmp=NULL,
					 *stmp2=NULL;
	struct DateTime *dtime=NULL;
	ULONG	pos=0;
	int		result=0;
	char	buffer[1000];
	BPTR	fh=NULL,p=NULL;
	struct	Filedata	*filedata=NULL;
	
	while (fileinfo[pos])
	{

		stmp=(struct DateStamp *) malloc (sizeof(struct DateStamp));
		dtime=(struct DateTime *) malloc (sizeof(struct DateTime));

		dtime->dat_Format=FORMAT_USA;
		dtime->dat_Flags=DTF_SUBST; /*ignored*/
		dtime->dat_StrDay=NULL; /*ignored*/
		dtime->dat_StrDate=fileinfo[pos]->delaydate;
		dtime->dat_StrTime=fileinfo[pos]->delaytime;
				
		if (StrToDate(dtime))

		{
			stmp2=(struct DateStamp *) malloc (sizeof(struct DateStamp));
			stmp=&dtime->dat_Stamp;
			DateStamp( stmp2 );
			result=CompareDates(stmp,stmp2);
			free(stmp2);
		}

		free(stmp);
		free(dtime);
		
		if (result>=0)
		{
			sprintf(buffer,"%s%s",fileinfo[pos]->filepath,fileinfo[pos]->filename);
			strcat(buffer,".dat");
			DeleteFile(buffer);





					if (filedata=(struct Filedata *) AllocMem(sizeof(struct Filedata),MEMF_PUBLIC|MEMF_CLEAR))
					{
						
						strcpy(buffer,fileinfo[pos]->filename);
						upperstring(buffer);
						p=NULL;
						Forbid();
						p=(BPTR)FindSemaphore(buffer);
						Permit();
						if (!p)
						{
							filedata->semi.ss_Link.ln_Pri=0;
							filedata->semi.ss_Link.ln_Name=filedata->filename;
							
							strcpy(filedata->filename,buffer);
							strcpy(filedata->filepath,fileinfo[pos]->filepath);
							strcpy(filedata->nodenumber,fileinfo[pos]->nodenumber);
							strcpy(filedata->handle,fileinfo[pos]->handle);
							strcpy(filedata->confpath,fileinfo[pos]->confpath);
							strcpy(filedata->dirinkbyte,fileinfo[pos]->dirinkbyte);
							strcpy(filedata->slotnumber,fileinfo[pos]->slotnumber);
							filedata->confnumber=fileinfo[pos]->confnumber;

							filedata->Main_Fileid=NULL;
							filedata->Filesize=0;

							filedata->MsgBase=FALSE;
							filedata->Hold=FALSE;
							filedata->Delay=FALSE;
							filedata->Immediately=TRUE;

							filedata->bghandler=FALSE;
							filedata->confnumber=fileinfo[pos]->confnumber;


							AddSemaphore((struct SignalSemaphore *)filedata);	
						}			

					}
					
			
					filedata=NULL;


			sprintf(buffer,"run <>nil: bbs:bgcheck/bgfilehandler \"%s\"",fileinfo[pos]->filename);	
			SystemTags(buffer,NP_StackSize,20000,TAG_DONE);
			Delay(2*TICKS_PER_SECOND);

		}
		pos++;
	}
}
