#define REVISION "V2.01"
#define AUTHOR   "Joe Cool"
#define ws WriteStr

#include <exec/types.h>
#include <exec/ports.h>
#include <exec/memory.h>
#include <dos/dos.h>
#include <dos/dostags.h>
#include <clib/exec_protos.h>
#include <clib/dos_protos.h>
#include <clib/alib_protos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include "env:timedate.h"


struct ConfCfg
{
 int  ConfNum;
 char ConfName[100];
 char ConfLoc[255];
 char MsgLoc[255];
 char Password[30];
 BOOL SentBy;
 BOOL MsgShared;
};


struct MailHeader 
{
	char	Status[1];
	long	MsgNumb;
	char	ToName[31],
			FromName[31],
			Subject[31];
	long	MsgDate,
			Recv;
	UBYTE	Conference;
};

struct MailStat
{
	long	LowestKey,
			HighMsgNum,
			LowestNotDel;
	char	Pad[6];
};

struct ansi
{
	int		ansicode;
	char	buf[20];
};

struct delayfile
{
	char	delaydate[9];
	char	delaytime[9];
	char	filename[13];
	char	filepath[255];
	char	nodenumber[3];
	char	handle[45];
	char	confpath[255];
	char	dirinkbyte[2];
	char	slotnumber[6];
	int		confnumber;
};	

struct Filedata
{
	struct	SignalSemaphore semi;
	struct	MinList sl_List;

	char	filename[13];
	char	filepath[255];
	char	nodenumber[3];
	char	handle[45];
	char	confpath[255];
	char	dirinkbyte[2];
	char	slotnumber[6];
	int		confnumber;

	char	**Main_Fileid;
	ULONG	Filesize;

	BOOL	MsgBase;
	BOOL	Hold;

	BOOL	Delay;
	char	delaydate[9];
	char	delaytime[9];
	BOOL	Immediately;

	BOOL	bghandler,
			add_fileid;
	char	movetopath[255];
	int		axx;
	BOOL	Filecheck_passed,
			Filecheck_ok,
			file_id_passed,
			file_id,
			all_passed,
			dupe;
  
};

struct HydraPort
{
  struct SignalSemaphore semi;
  struct MinList sl_List;
  UBYTE SemiName[20];
  char UpFileName[100];
  long UpFileSize;
  long UpFilePos;
  long UpCPS;
  char DnFileName[100];
  long DnFileSize;
  long DnFilePos;
  long DnCPS;
};

	

void timenow(char *buffer2)
{
	
	struct DateStamp *stmp=NULL;
	struct DateTime  *time=NULL;
	char	buffer[10]="";

	stmp=(struct DateStamp *) malloc (sizeof(struct DateStamp));
	time=(struct DateTime *) malloc (sizeof(struct DateTime));

	DateStamp(stmp);

	time->dat_Stamp=*stmp;
	time->dat_Format=FORMAT_USA;
	time->dat_Flags=DTF_FUTURE;
	time->dat_StrDay=NULL;
	time->dat_StrDate=NULL;
	time->dat_StrTime=buffer;

	DateToStr(time);

	free(stmp);
	free(time);
	strncpy(buffer2,buffer,5);
    buffer2[5]=0;
}






void Date(char *buffer,UBYTE format)
{
	
	struct DateStamp *stmp=NULL;
	struct DateTime  *time=NULL;

	stmp=(struct DateStamp *) malloc (sizeof(struct DateStamp));
	time=(struct DateTime *) malloc (sizeof(struct DateTime));

	DateStamp(stmp);

	time->dat_Stamp=*stmp;
	time->dat_Format=format;
	time->dat_Flags=DTF_FUTURE;
	time->dat_StrDay=NULL;
	time->dat_StrDate=buffer;
	time->dat_StrTime=NULL;

	DateToStr(time);

	free(stmp);
	free(time);
}

void lowerstring(char *s)
{
	while((*s=tolower(*s)) != '\0') s++;
}
void upperstring(char *s)
{
	while((*s=toupper(*s)) != '\0' && *s!=':') s++;
}


void stripansi(char *s,char *d,struct ansi *ansi,int resetit,int strip)
{
	register int i,j,k,p;
	if(resetit)
	{
		ansi->ansicode=0;
		return;
	}
	i=strlen(s);
	j=k=0;
	while(j<i)
	{
		if(*(s+j)=='\r'&&strip)
		{
			j++;
			ansi->ansicode=0;
			continue;
		}
		if(!ansi->ansicode && *(s+j)!='')
		{
			*(d+k)=*(s+j);
			j++;
			k++;	
			continue;
		}
		else
		{
			if(ansi->ansicode)	
			{
				ansi->buf[ansi->ansicode]=*(s+j);
				if(ansi->ansicode==1 && *(s+j)!='[')
				{
					ansi->ansicode++;
					p=0;
					ansi->buf[ansi->ansicode]='\0';
					while(ansi->buf[p]!='\0')
					{
						*(d+k)=ansi->buf[p];
						k++;
						p++;
					}
					ansi->ansicode=0;
				}
				else
				{	
					switch(*(s+j))
					{
						case 'm'	:	ansi->ansicode=0;
										break;
						default		:	ansi->ansicode++;
										if((*(s+j)>='A' && *(s+j)<='Z') || (*(s+j)>='a' && *(s+j)<='z'))
										{
											p=0;
											ansi->buf[ansi->ansicode]='\0';
											while(ansi->buf[p]!='\0')
											{
												*(d+k)=ansi->buf[p];
												k++;
												p++;
											}
											ansi->ansicode=0;
										}
										break;
					}
				}
			}
			else
			if(*(s+j)=='')
			{
				ansi->buf[0]='';
				ansi->ansicode=1;
			}
		}
		j++;
	}
	*(d+k)='\0';
}

void replace(char *source,char *destination,char *temp,char *repl,char *with)
{

	char	*p=NULL,	*p2=NULL;
	int		len=0;
	BOOL	rep=FALSE;
	
	strcpy (temp,source);
	p=temp;
	for (;p2=strstr(temp,repl);)
	{
		if (p2)
		{
			len=p2-p;
			strncpy(destination,temp,len);
			destination[len]=0;
			strcat(destination,with);
			strcat(destination,temp+len+strlen(repl));
			strcpy(temp,destination);
			p=temp;
			rep=TRUE;
		}
	}
	if (!rep) strcpy(destination,source);
}

LONG GetFileSize(char *FileName)
{
	struct  FileInfoBlock   *fib = NULL;
	LONG	filesize=0;
	BOOL 	fibsucc=FALSE;	
	BPTR	lock=NULL;

	fib=AllocDosObject(DOS_FIB,NULL);
	lock=Lock(FileName,ACCESS_READ);
	if (lock)
	{
		fibsucc=Examine( lock,fib);
		if (fibsucc) 
		{	
			filesize=fib->fib_Size;
		}
		UnLock(lock);
	}
	FreeDosObject(DOS_FIB, fib);
	return(filesize);
}


void GetFileDate(char *buffer,char *FileName,UBYTE format)
{
	struct  FileInfoBlock   *fib = NULL;
	struct  DateStamp       *filedate=NULL;
	BOOL 	fibsucc=FALSE;	
	BPTR	lock=NULL;
	struct DateTime  *time=NULL;

	time=(struct DateTime *) malloc (sizeof(struct DateTime));
	fib=AllocDosObject(DOS_FIB,NULL);
	lock=Lock(FileName,ACCESS_READ);
	if (lock)
	{
		fibsucc=Examine( lock,fib);
		if (fibsucc) 
		{	
			filedate=&fib->fib_Date;
			
			time->dat_Stamp=*filedate;
			time->dat_Format=format;
			time->dat_Flags=DTF_FUTURE;
			time->dat_StrDay=NULL;
			time->dat_StrDate=buffer;
			time->dat_StrTime=NULL;
			DateToStr(time);
		}
		UnLock(lock);
	}
	FreeDosObject(DOS_FIB, fib);
	free(time);
}

struct DateStamp *GetFileDateTime(char *FileName)
{
	struct  FileInfoBlock   *fib = NULL;
	BOOL 	fibsucc=FALSE;	
	BPTR	lock=NULL;
	struct DateStamp  *time=NULL;

	time=(struct DateStamp *) malloc (sizeof(struct DateStamp));
	fib=AllocDosObject(DOS_FIB,NULL);
	lock=Lock(FileName,ACCESS_READ);
	if (lock)
	{
		fibsucc=Examine( lock,fib);
		if (fibsucc) 
		{	
			time->ds_Days=fib->fib_Date.ds_Days;
			time->ds_Minute=fib->fib_Date.ds_Minute;
			time->ds_Tick=fib->fib_Date.ds_Tick;
		}
		UnLock(lock);
	}
	FreeDosObject(DOS_FIB, fib);
	return(time);
}



BOOL copy(char *source,char *destination)
{

	APTR	p=NULL;
	BPTR	readfh=NULL, 	writefh=NULL;
	BOOL	copied=FALSE;
	LONG	stat1=0,stat2=0;

	p=AllocMem((2*16384)+1,MEMF_PUBLIC);
	if (!p) return (copied);

	readfh=Open(source,MODE_OLDFILE);
	writefh=Open(destination,MODE_NEWFILE);
	
	if (!readfh || !writefh)
	{
		if (readfh) Close (readfh);
		if (writefh) Close (writefh);
	}
	else
	{
		do
		{
			stat1=Read(readfh,p,(2*16384));   /* Read from file */
			if(stat1>0) stat2=Write(writefh,p,stat1); /* write to file*/
		} 
		while(stat1>0&&stat2>0);

		Close(writefh);
		Close(readfh);
		if (stat1<0 || stat2<0) copied=FALSE; else copied=TRUE;
	}
	FreeMem(p, (2*16384)+1);
	return(copied);
}
char *getconfig(char **main_search,char *lookfor)
{
	char 	*p=NULL,	*q=NULL;
	ULONG	pos=0;
	
	for (pos=0;main_search[pos]!=NULL && (!p);pos++)
	{
		q=main_search[pos];
		if (q[0]!=';')
		{
			for (;!isalnum(*q);q++);
			if (strncmp(q,lookfor,strlen(lookfor))==0)
			{
				p=q+strlen(lookfor);
				if (*p!=0) p++;
				for (;isspace(*p);p++);
			}	
		}
	}
	return p;
			
}
BOOL getconfigbool(char **main_search,char *lookfor,BOOL std)
{
	char *p=NULL;
	p=getconfig(main_search,lookfor);
	if (p) 
	{
		upperstring(p);
		if (p[0]=='Y') 
			return(TRUE);
		else
			return(FALSE);
	}
	else return(std);
}

char **strip(char **main_fileid,int maxfidlines)
{
	BPTR	stripread=NULL;
	char	buffer[255],	
			*p=NULL,
			**main_strip=NULL,
			**main_newid=NULL;
	BOOL	strip=FALSE;
	int		pos=0,
			pos1=0,
			pos2=0,
			len=0,
			counter=0,
			stripnr=0;
	struct	ansi			*ansi;
			
	ansi=(struct ansi *) malloc(sizeof(struct ansi));

	main_strip=(char **) realloc(main_strip,sizeof(char *));
	main_strip[0]=NULL;
	main_newid=(char **) realloc(main_newid,sizeof(char *));
	main_newid[0]=NULL;

	strcpy(buffer,"bbs:bgcheck/bgfilehandler.strip");
	stripread=Open(buffer,MODE_OLDFILE);

	if (stripread)
	{
		for (pos=0;FGets(stripread,buffer,254);pos++)
		{
			main_strip=(char **) realloc(main_strip,(pos+1)*sizeof(char *));
			main_strip[pos]=NULL;
			len=strlen(buffer);
			if (buffer[len-1]=='\n') buffer[len-1]='\0';
			main_strip[pos]=(char *) malloc (len+1);
			if (main_strip[pos])
				strcpy(main_strip[pos],buffer);
		}
		Close(stripread);
		main_strip=(char **) realloc(main_strip,(pos+1)*sizeof(char *));
		main_strip[pos]=NULL;
	}

	p=(char *) malloc(300);
	for (pos=0;main_fileid[pos];pos++)
 	{	
		for (counter=0;counter<=strlen(main_fileid[pos]);counter++)
		{
			if (main_fileid[pos][counter]=='\n') main_fileid[pos][counter]='\0';
			if (main_fileid[pos][counter]==13) main_fileid[pos][counter]='\0';
		}		
		strip=FALSE;
		if (isspace(main_fileid[pos][0]))
		{
			strip=TRUE;
		}
	
		if (strip)
		{
			for (counter=0;counter<strlen(main_fileid[pos]);counter++)
			{	
				if (strip) 
				{
					if (main_fileid[pos][counter]!=' ' && main_fileid[pos][counter]!='\t') 
					{
						strip=FALSE;
					}
				}
			}		
		}

		if (strlen(main_fileid[pos])==0) 
		{
				strip=TRUE;
		}

		ansi->ansicode=0;
		stripansi(main_fileid[pos],buffer,ansi,0,0);
		sprintf(main_fileid[pos],"%.45s",buffer);
		for (pos1=0;main_strip[pos1];pos1++)
		{	
			if (main_fileid[pos][0]!='/' || pos!=0)
			{
				if (!strip)
				{
					if (strcmp(main_fileid[pos],main_strip[pos1])==0) strip=TRUE;
					if (!strip) 
					{
						ParsePattern(main_strip[pos1],p,300);
						if (MatchPattern(p, main_fileid[pos])) strip=TRUE;
					}
				}
			}	
		}
	
		if (pos2>=maxfidlines) strip=TRUE;
		if (strip==FALSE) 
		{
			main_newid=(char **) realloc(main_newid,(pos2+1)*sizeof(char *));
			main_newid[pos2]=NULL;
			len=strlen(main_fileid[pos]);
			main_newid[pos2]=(char *) malloc (len+1);
			if (main_newid[pos2]!=NULL)
				strcpy(main_newid[pos2],main_fileid[pos]);
			pos2++;	
		}
		else stripnr++;
	}
	main_newid=(char **) realloc(main_newid,(pos2+1)*sizeof(char *));
	main_newid[pos2]=NULL;

	for (pos=0;main_strip[pos]!=NULL;pos++)
		free(main_strip[pos]);
	free (main_strip);
	for (pos=0;main_fileid[pos]!=NULL;pos++)
		free(main_fileid[pos]);
	free (main_fileid);
	free(p);
	free(ansi);

	return (main_newid);
}


BOOL filecheck(char *endung,struct Filedata *filedata,char *fcheck,char *filepath,char *filename,char *handle,char *confpath,char *nodenumber,char *timestr,char *date)
{

	BOOL			error=0;
	long			pos=0,len=0,pos2=0;
	char			**main_test=NULL,buffer[255],buffer2[255],buffer3[255],buffer4[255],
					*p=NULL,*q=NULL;
	BPTR			readfh=NULL;

	main_test=(char **) realloc(main_test,sizeof(char *));
	main_test[0]=NULL;

	sprintf(buffer,"bbs:bgcheck/Fcheck/%s",endung);
	readfh=Open(buffer,MODE_OLDFILE);
	if (readfh) 
	{
		for (pos=0;FGets(readfh,buffer,254);pos++)
		{
			main_test=(char **) realloc(main_test,(pos+1)*sizeof(char *));
			main_test[pos]=NULL;
			len=strlen(buffer);
			if (buffer[len-1]=='\n') buffer[len-1]='\0';
			upperstring(buffer);
			main_test[pos]=(char *) malloc (len+1);
			if (main_test[pos]!=NULL)
			strcpy(main_test[pos],buffer);
		}
		Close(readfh);
		main_test=(char **) realloc(main_test,(pos+1)*sizeof(char *));
		main_test[pos]=NULL;
	}
	p=buffer; /*damit p!=NULL!*/
	error=FALSE;
	for (pos=1;p!=NULL && error!=TRUE;pos++)
	{
		sprintf(buffer4,"CHECK.%d",pos);
		if (p=getconfig(main_test,buffer4))
		{
			strcpy(buffer,p);
			replace(buffer,buffer2,buffer3,"%P",filepath);
			replace(buffer2,buffer,buffer3,"%F",filename);
			replace(buffer,buffer2,buffer3,"%H",handle);
			replace(buffer2,buffer,buffer3,"%C",confpath);
			replace(buffer,buffer2,buffer3,"%N",nodenumber);
			replace(buffer2,buffer,buffer3,"%T",timestr);
			replace(buffer,buffer2,buffer3,"%D",date);
			sprintf(buffer4,"t:%s.tst",filename);
			replace(buffer2,buffer,buffer3,"%OUT",buffer4);
			strcpy(buffer2,buffer);
			if (strstr(buffer2,buffer4)) sprintf(buffer,"%s",buffer2);
			else sprintf(buffer,"%s >%s",buffer2,buffer4);
			System(buffer,NULL);
			sprintf(buffer4,"t:%s.tst",filename);
			readfh=Open(buffer4,MODE_OLDFILE);
			if(readfh)
			{
				while(FGets(readfh,buffer2,200))
				{
					q=buffer; /*damit q!=NULL!*/
					for (pos2=1;q!=NULL;pos2++)
					{
						sprintf(buffer4,"ERROR.%d.%d",pos,pos2);
						if (q=getconfig(main_test,buffer4))
						{
							strcpy(buffer,q);
							if(strstr(buffer2,buffer)) error=TRUE;
						}
					}
				}
				Close(readfh);
				sprintf(buffer4,"t:%s.tst",filename);
				DeleteFile(buffer4);
				if (!error) *fcheck='P'; 
				else 
				{
					*fcheck='F'; 
					q=NULL;
					p=NULL;
				}
			}	
		}
	}					

	for (pos=0;main_test[pos];pos++)
		free(main_test[pos]);
	free(main_test);

	ObtainSemaphore((struct SignalSemaphore *) filedata);
	if (error)
	{	
		filedata->Filecheck_ok=FALSE;
		filedata->Hold=TRUE;
	}
	else 
	{
		filedata->Filecheck_ok=TRUE;
	}
	filedata->Filecheck_passed=TRUE;
	ReleaseSemaphore((struct SignalSemaphore *) filedata);
	return(error);
}




void putonline(struct Filedata *filedata,char *filelist,char **main_fileid,char *from,char *to,BOOL del_file,BOOL dirinkbyte,BOOL dlc,ULONG filesize,char *filename,char fcheck,char *date,BOOL fiddate,char *fileiddate)
{
	char buffer[255]="",buffer2[255]="",buffer3[255]="";
	BPTR writefh=NULL;
	int	try=0;
	long line=0,pos=0;

	do 
	{
		writefh=Open(filelist,MODE_READWRITE);
		if (!writefh) Delay(TICKS_PER_SECOND/6);
		try++;
	} while(!writefh || try==(TICKS_PER_SECOND*60));
	if (try==(TICKS_PER_SECOND*60)) return;

	Seek( writefh, 0, OFFSET_END);

	if (filesize>9999999) dirinkbyte=TRUE;
	line=1;pos=0;
	while(main_fileid[pos])
	{
		strcpy(buffer,main_fileid[pos]);
		pos++;	
		if (line==1) 
		{
			if (dirinkbyte)
			sprintf(buffer2,"%-12.12s %c%6ldk  %s  %s\n",filename,fcheck,(filesize/1024)+1,date,buffer);
			else
				sprintf(buffer2,"%-12.12s %c%7ld  %s  %s\n",filename,fcheck,filesize,date,buffer);
		}						
		else 
		{
			if (line==2)
			{
				if (dlc)
					sprintf(buffer3, "%-5.5sDL:   0  ","");
				else 
					sprintf(buffer3, "%-14.14s","");
		
				if (fiddate)
					sprintf(buffer2,"%sFileID:  %s  %s\n",buffer3,fileiddate,buffer);
				else
					sprintf(buffer2,"%s%-19.19s%s\n",buffer3,"",buffer);
			}
			else
				sprintf(buffer2,"%-33.33s%s\n","",buffer);
		}
		FPuts(writefh,buffer2);
		line++;	
	}
	Close(writefh);
	copy(from,to);
	ObtainSemaphore((struct SignalSemaphore *) filedata);
	strcpy(filedata->movetopath,to);
	ReleaseSemaphore((struct SignalSemaphore *) filedata);						

	if (del_file)
	{
		writefh=Open(from,MODE_NEWFILE);
		if (writefh) Close(writefh);				
	}
}



void autofreemail(char **main_fileid,int confnumber,char *autofree_mail_fromname,char *autofree_mail_subject,char *filename,ULONG filesize)
{
	struct ConfCfg *confcfg=NULL;
	BPTR readfh=NULL,lock=NULL,writefh=NULL;
	char	buffer[255]="",buffer2[255]="";
	struct MailStat *mailstat=NULL;
	struct MailHeader *mailheader=NULL;
	ULONG 	msgnum=0;
	long	len=0,pos=0,msgdate=0;

	confcfg=(struct ConfCfg *) malloc( sizeof(struct ConfCfg));
	readfh=Open("bbs:Conferences.dat",MODE_OLDFILE);
	Seek(readfh,(confnumber-1)*sizeof(struct ConfCfg),OFFSET_BEGINNING);
	Read(readfh,confcfg,sizeof(struct ConfCfg));
	Close(readfh);
	if (confcfg->MsgLoc[0]!=0) strcpy(buffer,confcfg->MsgLoc);
	else 
	{
		strcpy(buffer,confcfg->ConfLoc);
		strcat(buffer,"MsgBase/");
	}						
	free(confcfg);
	strcpy(buffer2,buffer);
	strcat (buffer2,"MailLock");
	lock=Lock(buffer2,ACCESS_WRITE);
	len=0;
	while (!lock && (len<20))
	{
		Delay(TICKS_PER_SECOND);
		lock=Lock(buffer2,ACCESS_WRITE);
		len++;
	}
	if (lock)
	{
		strcpy(buffer2,buffer);
		strcat(buffer2,"MailStats");
		mailstat=(struct MailStat *)malloc(sizeof(struct MailStat));
		readfh=Open(buffer2,MODE_READWRITE);
		Read(readfh,mailstat,sizeof(struct MailStat));
		msgnum=mailstat->HighMsgNum;
		mailstat->HighMsgNum++;
		Seek(readfh,0,OFFSET_BEGINNING);
		Write(readfh,mailstat,sizeof(struct MailStat));
		Close(readfh);
		free(mailstat);
		strcpy(buffer2,buffer);
		strcat(buffer2,"HeaderFile");
		mailheader=(struct MailHeader *) malloc (sizeof (struct MailHeader));
		mailheader->Status[0]='P';
		mailheader->MsgNumb=msgnum;
		strcpy(mailheader->ToName,"eall");
		strcpy(mailheader->FromName,autofree_mail_fromname);
		strcpy(mailheader->Subject,autofree_mail_subject);
		time(&msgdate);
		mailheader->MsgDate=msgdate;
		mailheader->Recv=0;
		mailheader->Conference=0;
		readfh=Open(buffer2,MODE_READWRITE);	
		Seek(readfh,0,OFFSET_END);
		Write(readfh,mailheader,sizeof(struct MailHeader));
		Close(readfh);
		strcpy(buffer2,buffer);
		sprintf(buffer,"%d",msgnum);
		strcat(buffer2,buffer);
		writefh=Open(buffer2,MODE_NEWFILE);

		FPuts(writefh,"\n[35m- --------------------------------------------------------------------- -[0m\n");
		FPuts(writefh,"      [33m__         [36mb[0mGCHECKER [36mb[0mY [36mj[0mOE [36mc[0mOOL "REVISION" ("REVDATE")\n");
		FPuts(writefh,"[35m- ----[33m\\/[35m--------------------------------------------------------------- -[0m\n\n");
		sprintf(buffer," [35m[ [36msTATUS[35m: [0;1mfREE dOWN [0;35m]  [ [36mfILEnAME[35m: [0;1m%s[0;35m ][0m  [35m[ [36mfILELENG[35m: [0;1m%d [0;35m][0m\n\n",filename,filesize);
		FPuts(writefh,buffer);
		pos=0;
		while(main_fileid[pos])
		{
			sprintf(buffer,"%20.20s%s\n","",main_fileid[pos]);	
			FPuts(writefh,buffer);
			pos++;
		}
		FPuts(writefh,"[35m- --------------------------------------------------------------------- -[0m\n");
		Close(writefh);
		UnLock(lock);
	}
}

BOOL dupecheck(struct Filedata *filedata,BOOL dupecheckglobal,char *buffer,char *buffer2)
{
        char    *p=NULL,*q=NULL;
        int             len=0,confnumber=0,pos=0;
        BPTR    fh=NULL;
        BOOL    other=FALSE,dupe=FALSE;
        long    time=0;
        LONG    size=0;

        p=(char *) malloc (20000*sizeof(char));
        if (!p) return(FALSE);

        ObtainSemaphore((struct SignalSemaphore *) filedata);
        strcpy(buffer2,filedata->filename);
        confnumber=filedata->confnumber;
        ReleaseSemaphore((struct SignalSemaphore *)filedata);

        len=strlen(buffer2);
        if (dupecheckglobal) sprintf(buffer,"bbs:bgcheck/globaldupe.log");
        else sprintf(buffer,"bbs:bgcheck/conf%ddupe.log",confnumber);
        pos=0;
        fh=Open(buffer,MODE_READWRITE);
        while (!fh && pos<60)
        {
                pos++;
                fh=Open(buffer,MODE_READWRITE);
                if (!fh) Delay(20);
        }
        if (!fh) return(FALSE);
        while ((size=Read(fh,p,1538*13)) && !dupe)
        {
                q=p;
                time=0;
                while(time<(size/13) && !dupe)
                {
                        
                        pos=0;
                        other=FALSE;
                        while (pos<len-1 && !other)
                        {
                                if (q[pos]!=buffer2[pos]) other=TRUE;
                                pos++;
                        }
                        if (!other) dupe=TRUE;
                        time++;
                        q+=13;  
                }
        }
        Close(fh);

        free(p);

        if (dupe)
        {
                ObtainSemaphore((struct SignalSemaphore *) filedata);
                filedata->dupe=TRUE;
                filedata->Hold=TRUE;
                ReleaseSemaphore((struct SignalSemaphore *)filedata);
        }
        if (dupe) return(TRUE); else return(FALSE);

}
void dupeadd(struct Filedata *filedata,BOOL dupecheckglobal,char *buffer,char *buffer2)
{
	int		confnumber=0;
	BPTR	fh=NULL;
	long	pos=0,len=0;

	ObtainSemaphore((struct SignalSemaphore *) filedata);
	strcpy(buffer2,filedata->filename);
	confnumber=filedata->confnumber;
	ReleaseSemaphore((struct SignalSemaphore *)filedata);
    len=strlen(buffer2);
	if (dupecheckglobal) sprintf(buffer,"bbs:bgcheck/globaldupe.log");
	else sprintf(buffer,"bbs:bgcheck/conf%ddupe.log",confnumber);
	pos=0;
	fh=Open(buffer,MODE_READWRITE);
	while (!fh && pos<60)
	{
		pos++;
		fh=Open(buffer,MODE_READWRITE);
		if (!fh) Delay(20);
	}

	for(pos=len;pos<12;pos++) buffer2[pos]=' ';
	buffer2[12]='\n';
	buffer2[13]='\0';
	Seek(fh,0,OFFSET_END);
	FPuts(fh,buffer2);
	Close(fh);

}

