#define PROGNAME "Quicknew.starttool"
#define REVISION "V1.0"
#define AUTHOR   "Joe Cool"

#include <exec/types.h>
#include <exec/ports.h>
#include <exec/memory.h>
#include <dos/dos.h>
#include <dos/dostags.h>
#include <clib/exec_protos.h>
#include <clib/dos_protos.h>
#include <clib/alib_protos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include "env:timedate.h"

struct Filedata
{
	struct	SignalSemaphore semi;
	struct	MinList sl_List;

	char	filename[13];
	char	filepath[255];
	char	nodenumber[3];
	char	handle[45];
	char	confpath[255];
	char	dirinkbyte[2];
	char	slotnumber[6];
	int		confnumber;

	char	**Main_Fileid;
	ULONG	Filesize;

	BOOL	MsgBase;
	BOOL	Hold;

	BOOL	Delay;
	char	delaydate[9];
	char	delaytime[9];
	BOOL	Immediately;

	BOOL	bghandler,
			add_fileid;
	char	movetopath[255];
	int		axx;
	BOOL	Filecheck_passed,
			Filecheck_ok,
			file_id_passed,
			file_id,
			all_passed,
			dupe;
  
};

void replace(char *source,char *destination,char *temp,char *repl,char *with);
void Date(char *buffer,UBYTE format);
LONG GetFileSize(char *FileName);

static const char VersionTag[] = "\0$VER: "PROGNAME" "REVISION" by "AUTHOR" at "REVDATE" "REVTIME"";
void main(int argc, char *argv[])
{

	BPTR	readfh=NULL;
	char	buffer[500]="",date[10]="";

	struct	Filedata	*filedata=NULL;
	BOOL	hold=FALSE;
	int		confnumber=0;
	long	filesize=0;
	
	Forbid();
	filedata=(struct Filedata *)FindSemaphore(argv[1]);
	Permit();
	if (!filedata) Exit(5);
	
	ObtainSemaphore((struct SignalSemaphore *) filedata);
	hold=filedata->Hold;
	confnumber=filedata->confnumber;
	sprintf(buffer,"%s%s",filedata->filepath,filedata->filename);
	ReleaseSemaphore((struct SignalSemaphore *) filedata);
	filesize=GetFileSize(buffer);

	Date(date,FORMAT_USA);
	if (!hold)
	{
		sprintf(buffer,"bbs:bgcheck/quicknewdata.%d",confnumber);
		readfh=Open(buffer,MODE_READWRITE);
		if (readfh)
		{
			FGets(readfh,buffer,200);
			FGets(readfh,buffer,200);
			if (!strncmp(buffer,date,8))
			{
					Seek(readfh,0,OFFSET_END);
				sprintf(buffer,"%s %d\n",argv[1],filesize);
				FPuts(readfh,buffer);
				Close(readfh);
			}
			else
				{
				Close(readfh);
				sprintf(buffer,"bbs:bgcheck/quicknewdata.%d",confnumber);
				readfh=Open(buffer,MODE_NEWFILE);
				FPuts(readfh,"@QUICKNEW@\n");
					FPuts(readfh,date);
				FPuts(readfh,"\n");
				sprintf(buffer,"%s %d\n",argv[1],filesize);
				FPuts(readfh,buffer);
				Close(readfh);
			}
		}		
	}
		
				
			
}

void replace(char *source,char *destination,char *temp,char *repl,char *with)
{

	char	*p=NULL,	*p2=NULL;
	int		len=0;
	BOOL	rep=FALSE;
	
	strcpy (temp,source);
	p=temp;
	for (;p2=strstr(temp,repl);)
	{
		if (p2)
		{
			len=p2-p;
			strncpy(destination,temp,len);
			destination[len]=0;
			strcat(destination,with);
			strcat(destination,temp+len+strlen(repl));
			strcpy(temp,destination);
			p=temp;
			rep=TRUE;
		}
	}
	if (!rep) strcpy(destination,source);
}

void Date(char *buffer,UBYTE format)
{
	
	struct DateStamp *stmp=NULL;
	struct DateTime  *time=NULL;

	stmp=(struct DateStamp *) malloc (sizeof(struct DateStamp));
	time=(struct DateTime *) malloc (sizeof(struct DateTime));

	DateStamp(stmp);

	time->dat_Stamp=*stmp;
	time->dat_Format=format;
	time->dat_Flags=DTF_FUTURE;
	time->dat_StrDay=NULL;
	time->dat_StrDate=buffer;
	time->dat_StrTime=NULL;

	DateToStr(time);

	free(stmp);
	free(time);
}

LONG GetFileSize(char *FileName)
{
	struct  FileInfoBlock   *fib = NULL;
	LONG	filesize=0;
	BOOL 	fibsucc=FALSE;	
	BPTR	lock=NULL;

	fib=AllocDosObject(DOS_FIB,NULL);
	lock=Lock(FileName,ACCESS_READ);
	if (lock)
	{
		fibsucc=Examine( lock,fib);
		if (fibsucc) 
		{	
			filesize=fib->fib_Size;
		}
		UnLock(lock);
	}
	FreeDosObject(DOS_FIB, fib);
	return(filesize);
}

